/*
	ou c[
	Ȉꗗ
	ȒPʂ̋zo
	
*/
#define TITLE "BB MEMORY TOOL"


#include "mzprint.h"
#include "ndsetc.h"
#include "cardme.h"
#include "menuwin.h"
#include "dbg.h"
#include "mpcfio.h"
#include "memfile.h"
#include "savename.h"
#include "fileselect.h"


#define BBHEADSZ  (0x8000)	//	ouwb_TCY
#define BBSCORESZ (0x6000)	//	XRAf[^TCY
#define BBSN (0x40)			//	^CgP
#define BBSN2 (0x60)		//	^CgQ
#define BBBUN (8)		//	BBoN
#define SAVEBUN (32)	//	Z[u

//#define mem bb_memory
	u8 * bbmem;

int bb_stat=0;	//	0:no update  1:updated
int bb_bank[BBBUN];

void bb_disp_only(int x,int y);




void bb_print(u8 *msg)
{
	int i;
	u8 mh;
	u8 ml;
	for(i=0;i<32;i++)
	{
		int hir=0;
		mh=msg[i]& 0xF0;
		ml=msg[i]& 0x0F;
		if(msg[i]==0)break;
		
		if(msg[i]==0x7F)
		{
			bg_put(0x43 |0x400);	//g[t
			continue;
		}
		if(msg[i]==0xFE)
		{
			//bg_put(0xD5 |0x400);	//ق()
			bg_putc('*');	//ق(*)
			continue;
		}
		if(msg[i]==0xFF)
		{
			bg_put(0xC6 |0x400);	//(C)
			continue;
		}
		
		if(mh==0x80)
		{
			mh=0xA0;
			hir=1;
		}

		if(mh==0x90)
		{
			mh=0xB0;
			hir=1;
		}

		if(mh==0xE0)
		{
			mh=0xC0;
			hir=1;
		}

		if(mh==0xF0)
		{
			mh=0xD0;
			hir=1;
		}
		mz_kana=hir;
		bg_putc(mh | ml);
	}
}



		void	bb_dummy(void)
		{}
		void	bb_cancel(void)
		{
		//	bb_stat=0;
		}
		
void	bb_write_to_save(void)
{
	bb_stat=0;
	int tp;
	int sz;
	int i;

	cls(0);
	tp=cardmeGetType();
	sz=cardmeSize(tp);
	if(tp!=3)
	{
		print("DS CARD TYPE ERROR.");
		keywait();
		nkeywait();
	}
	locate(0,8);
	print("FLASH MEMORY erase ... ");
	cardmeChipErase();
	print("OK");

	locate(0,12);
	//     12345678901234567890123456789012
	print("-------+-------+-------+-------+");
	locate(0,13);
	print("0%    25%     50%     75%    100");
	for(i=0;i<SAVEBUN;i++)
	{
		locate(i,11);
		//	cardmeReadEeprom(i*sz/SAVEBUN,&bbmem[i*sz/SAVEBUN],sz/SAVEBUN,tp);
			cardmeWriteEeprom(i*sz/SAVEBUN,&bbmem[i*sz/SAVEBUN],sz/SAVEBUN,tp);
		print("#");
	}
	for(i=0;i<BBBUN;i++)
	{
		bb_bank[i]=0;
	}
	locate(0,15);
	print("OK");
		keywait();
		nkeywait();

}


void	bb_in_bbs(void)
{
	int i=0,oi=0;
	char *fn;
	//	oNIt@CI
	nkeywait();
	for(;;)
	{
		cls(0);
		print("   IN    BBS / BBS FILE -> RAM\n");
		print("Please choose the position to read.\n");
		bb_disp_only(5,7);
				locate(0,7+ i);print("->");
		for(;;)
		{
			keywait();
			if(isEXE)break;
			if(isCANCEL)
			{
				nkeywait();
				return;
			}
			oi=i;
			if(isCU)
			{
				i=(i-1+BBBUN)%BBBUN;
			}
			if(isCD)
			{
				i=(i+1)%BBBUN;
			}
			if(oi!=i)
			{
				locate(0,7+oi);print("  ");
				locate(0,7+ i);print("->");
			}
			nkeywait();
		}

		//	t@CI
		if(isemu()==0)
		if(! InitFiles())
		{
			locate(0,16);
			print("CF/SD NOT READY\n");
			keywait();
			nkeywait();
			return;
		}

		fn=fileselect(".BBS");
		if(fn==NULL)
		{
			FreeFiles();
			continue;
		}

		
		//	t@Cɓǂݍ
//		ret=memfile_save(buff,&bbmem[BBHEADSZ+ BBSCORESZ*i],BBSCORESZ);
		if(memfile_load(fn,&bbmem[BBHEADSZ+ BBSCORESZ*i],BBSCORESZ)<0)
		{
			cls(0);
			locate(0,16);
			print("CAN NOT READ BBS FILE.");
			keywait();
			nkeywait();
		}
		else
		{
			bb_bank[i]=1;
			bb_stat=1;	//XVtO
			cls(0);
			locate(0,16);
			print(fn);
			print(" READ OK.");
			keywaitn(30);
			nkeywait();
		}

		FreeFiles();

		

		//	ǂݍ݂͘Ačs悤ɂ邩H
		//	* BBSPʂ̍XVtO   ->*  bb_bank[i]
		
	}
}

void	bb_tool(void)
{
//	int i;
#define ITEMS (3)


		void	bb_disp(void);
		void	bb_bbs_all_save(void);
		void	bb_init(void);

menu_s data[]={
//{	"BACKUP  / DS SAVE -> SAVE FILE",	eep_save,},

{	"  DISP   BBS / RAM BBS LIST",	bb_disp,},
{	"   IN    BBS / BBS FILE -> RAM",	bb_in_bbs,},
//{	"   OUT   BBS / RAM -> BBS FILE",	bb_dummy,},
{	" OUT ALL BBS / RAM -> BBS FILE",	bb_bbs_all_save,},
//{	" DEL RAM BBS / ERASE RAM BBS",	bb_dummy,},
//{	" DEL RAM ALL / ERASE RAM ALL BBS",	bb_dummy,},
{	"WRITE BB SAVE/ RAM -> DS SAVE ",	bb_write_to_save,},
//{	"EXIT      / EXIT after B ",	bb_cancel,},

{	NULL,NULL,},
};
	char buf[80];
	int ret;
	char id[8+1]="\0\0\0\0\0\0\0\0";
	int otp=0;
	int sz=0;
	int tp=0;
	int i;
	char wk[4096];


	cls(0);
	locate(0,0);
		print(TITLE);
	locate(0,2);
	print("PLEASE INSERT BAN BRA CARD\n and PUSH A\n");
	nkeywait();
	
	if(isemu()==0)
	for(;;)
	{
		keywaitn(30);
		if(isCANCEL)return;
		if(isEXE)break;
		wait(30);

			tp=cardmeGetType();
			sz=cardmeSize(tp);

				if(tp!=otp)
				{
					sz=cardmeSize(tp);
					locate(0,4);
					sprintf(buf,"TYPE=%-2d SIZE=%dbyte ",tp,sz);print(buf);
					if(tp>0)
					{
						cardmeReadEeprom(0,(u8*)wk,4096,tp);
							if(getgameid((char *)wk,4096,id)>=0)
							{
								sprintf(buf,"id=%4s ",id);print(buf);
							}
							else
							{
								print("id=     ");
							}
							locate(0,5);
							
							sprintf(buf,"%s\n",getgamename((char *)data,4096,1));print(buf);
							sprintf(buf,"%s",getgamename((char *)data,4096,0));print(buf);
					}
					else
					{
					//         id=1234 name=12345678
						print("                      \n");
					//         1234567890123456
						print("                      \n");
					//         1234567890123456
						print("                      \n");
					}
					otp=tp;
				}
	};

	if(isemu()==0)
	{

		if(strcmp(id,"ABBJ")!=0)return;
	}
	
	bbmem=(u8 *)malloc(256*1024);
	if(bbmem==NULL)
	{
		print("\nMALLOC ERROR\n");
		keywait();
		nkeywait();
		return;
	}
	
	cls(0);
	locate(0,0);
		print(TITLE);
	locate(0,2);
	print("COPY BB SAVE TO RAM...\n");
	if(isemu()==0)
	{
		locate(0,5);
		//     12345678901234567890123456789012
		print("-------+-------+-------+-------+");
		locate(0,6);
		print("0%    25%     50%     75%    100");
		for(i=0;i<SAVEBUN;i++)
		{
			locate(i,4);
			print("#");
		//	cardmeReadEeprom(i*sz/BUN,&data[i*sz/BUN],sz/BUN,tp);
		//	cardmeReadEeprom(0,mem,sz,tp);
			cardmeReadEeprom(i*sz/SAVEBUN,&bbmem[i*sz/SAVEBUN],sz/SAVEBUN,tp);

		}
	}
	for(i=0;i<BBBUN;i++)
	{
		bb_bank[i]=0;
	}

	locate(0,7);
	print("OK\n");
//	wait(30);
	keywaitn(60);
	nkeywait();



	for(;;)
	{
		cls(0);
	
		locate(0,0);
		print(TITLE);
		//	Ď
			
		//	L[
		 bb_stat=0;	//	2:save end   1:cancel
		ret=menu_win(TITLE,data);
		if(bb_stat==0)
		{
			break;
		}
		else
		{
			cls(0);
			print(TITLE "\n");
			if(get_lang()==LANG_JP)
			{
				mz_hiragana();
				print("οݻòϾ\n");
				print("BB CARD οݽ:A\n");
				print(":B\n");
				mz_katakana();
			}
			else
			{
				print("not reflected in BB SAVE yet. \n");
				print("SAVE BB CARD:A\n");
				print("CANCEL:B\n");
			}
			for(;;)
			{
				nkeywait();
				keywait();
				if(isEXE)
				{
					bb_write_to_save();
					break;
				}
				if(isCANCEL)
				{
					break;
				}
			}
			break;
		}
		nkeywait();

	}
	free(bbmem);

	
}

void bb_disp_only(int x,int y)
{
	char buff[80];
	int i;
	for(i=0;i<BBBUN;i++)
	{
			locate(x+3,i+y);
			//	^Cgo
			sprintf(buff,"No.%d ",i+1);print(buff);
			bb_print(&bbmem[BBHEADSZ+ BBSCORESZ*i + BBSN]);
			bb_print(&bbmem[BBHEADSZ+ BBSCORESZ*i + BBSN2]);
			if(bb_bank[i]==1)
			{
				locate(x,i+y);
				print("(*)");
			}
	}
}





void	bb_disp(void)	//
{
	cls(0);
	print("BB DISP\n");
	bb_disp_only(5,7);
	locate(0,8+7);
	print("\nOK\n");
	nkeywait();
	keywait();
	return;
}






void	bb_bbs_all_save(void)	//	
{
	char buff[256];
	int i;
	tm t;

	cls(0);
	print("BB SCORE OUTPUT (BB SCORE -> CF)\n");
	
	time2(&t);

	for(i=0;i<BBBUN;i++)
	{
		int ret;
		locate(5,i+7);
		//	^Cgo
		sprintf(buff,"No.%d ",i+1);print(buff);
		bb_print(&bbmem[BBHEADSZ+ BBSCORESZ*i + BBSN]);
		bb_print(&bbmem[BBHEADSZ+ BBSCORESZ*i + BBSN2]);
		
		sprintf(buff,"BB_%02d%02d_%02d%02d%02d_No%02d.BBS",
		t.tm_mon ,
		t.tm_mday ,
		t.tm_hour ,
		t.tm_min ,
		t.tm_sec ,
		i+1
		); 

		
		ret=memfile_save(buff,&bbmem[BBHEADSZ+ BBSCORESZ*i],BBSCORESZ);
		if(ret<0)
		{
			print(" NG");
		}
		else
		{
			print(" OK");
		}
	}

	locate(0,8+7);
	print("\nEND.\n");
	nkeywait();
	keywait();
	return;

}

void	bb_init(void)
{
	cls(0);
	locate(0,11);
	print("޷òϾ sorry");
	nkeywait();
	keywait();

}

