#define TITLE "GBAMP CF I/O Test " "\n" __DATE__ " " __TIME__



#include "mzprint.h"
#include "ndsetc.h"
#include "mpcfio.h"

#define WT wait(10)

void dumpfile(const char* fn);

void cfiotest(void)
{
#define FILEMAX (20)
static	char flist[FILEMAX][256];
	int filenum=0;
	char fn[80];
	char buf[80];
	int ret=0;
	int ct;
	int i;
	
	for(;;)
	{
	
		cls(0);
		
		print(TITLE  "\n");
		
		for(;;)
		{
		//	if(CF_IsInserted())
			{
				//print("CF_IsInserted() OK\n");
				WT;
				if(! InitFiles())
				{
						print("InitFiles() NG >");
				WT;
						keywait();
						print("\n");
						nkeywait();
						continue;
				}
						print("InitFiles() OK\n");
				WT;
				break;
			}
		//	else
		//	{
		//		print("CF_IsInserted() NG >");
		//		WT;
		//		keywait();
		//		print("\n");
		//		nkeywait();
		//	}
		}
		
		
		CWD("/");
		
		filenum=0;
		ret=FindFirstFile(fn);
		for(;;)
		{
		//		WT;
			switch(ret)
			{
				case 1:
					GetLongFilename(fn);
					strcpy(flist[filenum],fn);
					filenum++;
				case 2:
					ct++;
					sprintf(buf,"%d fn=[%s]\n",ret,fn);
					print(buf);
					break;
				case 0:
				default:
					sprintf(buf,"%d -\n",ret);
					print(buf);
					break;
			}
			if(ret==1 || ret==2)
			{
			ret=FindNextFile(fn);
			}
			else
			{
				break;
			}
		}
		print("OK\n");
				WT;
//		keywait();
		nkeywait();
		
		//	t@C̑IXg
		if(filenum==0)continue;
		
		cls(0);
		print("FILE DUMP TEST\n");
		print("SELECT FILE\n");
		for(i=0;i<filenum;i++)
		{
			locate(0,i+3);
			sprintf(buf," %s",flist[i]); print(buf);
		}
		
		//	J[\\ƑI
		int cur=0;
			locate(0,cur+3); print(">");
		for(;;)
		{
			keywait();
			if(isCD)
			{
			locate(0,cur+3); print(" ");
				cur++;
				cur=cur%filenum;
			}
			if(isCU)
			{
			locate(0,cur+3); print(" ");
				cur--;
				if(cur<0)cur=filenum-1;
			}
			if(isEXE)
			{
				nkeywait();
				dumpfile(flist[cur]);
			}
			if(isCANCEL)
			{
				nkeywait();
				break;
			}
			locate(0,cur+3); print(">");
			nkeywait();
		}
	
	}
}


void dumpfile(const char* fn)
{
	u32 i,j,k=0;
//	u32 ad=0x80;
	u32 ad=0x10;
	u8 *a;
	char msg[128];
#define FILESZMAX (4096)
static	char dumpbuf[FILESZMAX];
	FILE *fp;
	int fs=0;
	u32 x=(u32)dumpbuf;
	u32 top=(u32)dumpbuf;

	mem2clear((uint32 *) dumpbuf,0x00000000,FILESZMAX);
	wait(1);

	cls(0);

		locate(0,0);
			sprintf(msg,"FILE:%s ",fn);
			print(msg);
	
	fp=fopen(fn,"r");	print("FO");
	if(fp==NULL)
	{
			print("\nfile open err\n");
			keywait();
			nkeywait();
			return;
	}
	print("FR");
	fs=fread(dumpbuf,1,FILESZMAX,fp);
	
		locate(0,1);
			sprintf(msg,"READ SIZE:%d bytes",fs);
			print(msg);
	fclose(fp);
	


	for(;;)
	{
		locate(0,2);
			
			k=x;
			sprintf(msg,"%08X-",k-top);
			print(msg);
		for(j=0;j<0x10;j++)
		{
			k=x+j*0x8;
			locate(0,j+3);
			sprintf(msg,"%04X:",(k-top)%0x10000);
			print(msg);
			for(i=0;i<0x8;i++)
			{
				if(k+i-top>=fs)
				{
				print("--");
				}
				else
				{
				a=(u8 *)k+i;
				sprintf(msg,"%02X",*a);
				print(msg);
				}
			}
			for(i=0;i<0x8;i++)
			{
				
				locate(22+i,j+3);
				if(k+i-top>=fs)
				{
				print(" ");
				}
				else
				{

					a=(u8 *)k+i;

					if(*a>=0x20 && *a<0x80)
					{
					msg[0]=*a;
					}
					else
					{
					msg[0]='.';
					}
					msg[1]=0;
					print(msg);
				}
			}
		}
	print("\nOK\n");
		keywait();
		
		if(isCANCEL)
		{
			return;
		}
		else
		if(isBREAK)
		{
			return;
		}
		if(isCU)
		{
			x-=ad;
		}
		if(isCD)
		{
			x+=ad;
		}
		if(isCR)
		{
			x+=ad*8;
		}
		if(isCL)
		{
			x-=ad*8;
		}
			if(x<top)x=top;
			if(x-top>fs+0x80*1)x=top+fs+0x80*1;


		wait(10);

	}

}



