
#include "ndsetc.h"
#include "mzprint.h"
#include "cardme.h"
#include "koyomi.h"
#include "tt.h"
#include "menuwin.h"
#include "mpcfio.h"

#ifndef ROMVER
#define ROMVER "r**"
#endif

#define TITLE "RAIN " ROMVER




void eep_info(void);



void eep_info(void)
{
	cls(0);
	print(
	TITLE  " [1/2]\n"
	"\n"
	"Creation date:\n"
	" " __DATE__ " " __TIME__ "\n"
	"\n"
	"Author: SaTa. \n"
	" http://www.pat.hi-ho.ne.jp/sata68/nds.shtml\n"
	"\n"
	"Technology and development environment:\n"
	" DevkitPRO 1.2.0\n"
	" http://www.geocities.com/chishm1/gbamp/\n"
	" http://forum.gbadev.org/\n"
	" http://neimod.com/dstek/\n"
	" http://www.kako.com/\n"
	" http://www.bbennett69.f2s.com/Index%20of%20-nds.htm\n"
	"\n"

	);
	nkeywait();
	keywait();
	cls(0);
	print(
	TITLE  " [2/2]\n"
	"\n"
	" Data sheet:M95040,M95640,M95512,LE25FW206,M45PE20,M45PE40\n"
	" GBAMP CF driver:\n"
	"  gba_nds_fat by chishm (Michael Chisholm) \n"
	"  for M3   by Mighty Max\n"
	"  mpcfio by SaTa. and moonlight\n"
    " GBAMP NDS Firmware Hack Version 2.0 By Michael Chisholm (Chishm)\n"
	"\n"
	" nds_compati.h by SaTa. for Public Domain\n"
	" a7sleep by SaTa. for Public Domain\n"
	" cardme by SaTa. for Public Domain\n"
	"\n"
	"Thanks:panyawo and jubai, Teke,\n"
	"\n"

	);
	nkeywait();
	keywait();
/*
	ׂe
	gpĂ郉Cu
	J
	bZ[W
	
	J_[ǉ\
*/
}




void saveutil(void)
{
		void	eep_save(void);
		void	eep_load(void);
		void	eep_init(void);
		void	dumpeep(void);
		void	eep_test(void);
		void	bb_tool(void);
		void	launch_menu(void);
		void	eep_save2(void);
		void	eep_load2(void);
		void	m3_man(void);



menu_s data1[]={
{	"BACKUP  / DS SAVE -> SAVE FILE",	eep_save,},
{	"RESTORE / DS SAVE <- SAVE FILE",	eep_load,},
{	"M3 MAN  / M3-SAVE(DAT) MANAGER",	m3_man,},

{	"DUMP    / DS SAVE DUMP DISP",	dumpeep,},
{	"BB TOOL / BAND-BROTHERS TOOL",	bb_tool,},
{	"FORMAT  / INITIALIZE DS SAVE",	eep_init,},
{	"TEST    / ANALYZE for debug",	eep_test,},
{	"KOYOMI  / Japanese calendar",	koyomi_ui,},
{	"LAUNCH  / LAUNCH NDS FILE",	launch_menu,},
{	"info.",						eep_info,},
{	NULL,NULL,},
};

menu_s data2[]={
{	"BACKUP  / DS SAVE -> SAVE FILE",	eep_save,},
{	"RESTORE / DS SAVE <- SAVE FILE",	eep_load,},
{	"M3 MAN  / M3-SAVE(DAT) MANAGER",	m3_man,},
{	"DUMP    / DS SAVE DUMP DISP",	dumpeep,	},
{	"BB TOOL / BAND-BROTHERS TOOL",	bb_tool,	},
{	"FORMAT  / INITIALIZE DS SAVE",	eep_init,	},
{	"TEST    / ANALYZE for debug",	eep_test,	},
{	"KOYOMI  / Japanese calendar",	koyomi_ui,	},
{	"info.",						eep_info,	},
{	NULL,NULL,									},
};

menu_s data3[]={
{	"BACKUP2 / DS SAVE -> GBA SRAM",		eep_save2,	},
{	"RESTORE2/ DS SAVE <- GBA SRAM",		eep_load2,	},
{	"DUMP    / DS SAVE DUMP DISP",	dumpeep,	},
{	"BB TOOL / BAND-BROTHERS TOOL",	bb_tool,	},
{	"FORMAT  / INITIALIZE DS SAVE",	eep_init,	},
{	"TEST    / ANALYZE for debug",	eep_test,	},
{	"KOYOMI  / Japanese calendar",	koyomi_ui,	},
{	"info.",						eep_info,	},
{	NULL,NULL,									},
};




	int passme=0;
	int cfflg=0;
	int menuf=3;




	int tp;

	int emu=isemu();

	cls(0);
	
	//	PassMe check
	if(emu==0)
	{
		print("NO emulator mode.\n");
		print("Card check\n");
		tp=cardmeGetType();
		if(tp==0)
		{
			cls(0);
			locate(0,10);
			//              111111111122222222223333333333    
			//     123456789012345678901234567890123456789
			if(get_lang()==LANG_JP)
			{
				mz_hiragana();
				print("ҲSAVE TYPE Ӽ PassMe޽\n");
				print("PassMe ʽ޼ø޻\n");
				mz_katakana();
			}
			else
			{
				print("unknown SAVE TYPE or PassMe.\n");
				print("Please remove PassMe and push a button.\n");
			}

			keywait();
			nkeywait();
			passme=1;
		}
		print("GBAMP check\n");


		if(!disc_Init())
		{
			cls(0);
			locate(0,10);
			//              111111111122222222223333333333    
			//     123456789012345678901234567890123456789
		//	print("CF is not contained in GBAMP\n or it is not GBAMP. \n");
		
			if(get_lang()==LANG_JP)
			{
				mz_hiragana();
				print("CF/SDʲïòϾݡ\n");
				mz_katakana();
				print("߰");
				mz_hiragana();
				print("òŲ\n");
				mz_katakana();
			}
			else
			{
				print("CF/SD is not contained \n or not support device. \n");
			}
			keywait();
			nkeywait();
		}
		else
		{
		//	cfflg=1;
			switch(disc_if())
			{
				case DISC_IF_SCCF:
				case DISC_IF_SCSD:
				case DISC_IF_MPCF:
				case DISC_IF_M3CF:
				case DISC_IF_M3SD:
//				case :
					cfflg=1;
					break;
				default:
					cfflg=0;
				print("not support device. \n");
			keywait();
			nkeywait();
			}
		}

	}
	else
	{
		print("emulator mode.\n");
			keywaitn(30);
			nkeywait();
			cfflg=1;
			passme=0;
	}
	
	if(cfflg==1)
	{
		
		if(passme==1 || disc_if()!=DISC_IF_MPCF)
		{
			menuf=2;
		}
		else
		{
			menuf=1;
		}
	}
	else
	{
		menuf=3;
	}
	for(;;)
	{
		int ret=0;
		switch(menuf)
		{
			case 1:
				ret=menu_win(TITLE,data1);
				break;
			case 2:
				ret=menu_win(TITLE,data2);
				break;
			case 3:
				ret=menu_win(TITLE,data3);
				break;
			default:
				print("unknown err.\n");
				nkeywait();
				keywait();
				ret=-1;
		}
		if(ret<0)break;
	
	}
	cls(0);
	nkeywait();
	print(".");
	keywaitn(60);


	

}

