//////////////////////////////////////////////////////////////////////
// Simple ARM9 demo (touch screen controls the colors)
// -- joat
//////////////////////////////////////////////////////////////////////

#include <nds.h>

//////////////////////////////////////////////////////////////////////

#include "ndsetc.h"
#include "dbg.h"
#include "tt.h"

void dumpmain(void );
void dumpeep(void);
void saveutil(void);

void InterruptHandler(void) {
  static unsigned int counter = 0;

  if (IF & IRQ_VBLANK) {
    counter++;

//    PALETTE[0] = RGB15(IPC->touchX>>7, IPC->touchY>>7, (counter>>4)&0x1F);
//    PALETTE[512] = RGB15(0, IPC->touchZ1>>7, IPC->touchZ2>>7);
	tt_pal_anime();


    IF = IRQ_VBLANK;
  }
}

//////////////////////////////////////////////////////////////////////

int main(int argc, char ** argv) {

/*
  // Red main screen, blue sub-screen
  PALETTE[0] = RGB15(0, 0, 31);
  PALETTE[512] = RGB15(31, 0, 0);

  // Turn on the screens and 2D cores and switch to mode 0
  DISPLAY_CR = MODE_0_2D | DISPLAY_BG0_ACTIVE;
  SUB_DISPLAY_CR = MODE_0_2D | DISPLAY_BG0_ACTIVE;

*/

	POWER_CR |= POWER_ALL_2D;
	


  // Enable the V-blank interrupt
  IME = 0;
  IRQ_HANDLER = &InterruptHandler;
  IE = IRQ_VBLANK;
  IF = ~0;
  DISP_SR = DISP_VBLANK_IRQ;
  IME = 1;




	while(1)
	{
//		wait(10);
		dbgmain();

		saveutil();




	}
  // Sleep to save power
//  while (1) swiWaitForVBlank();
  return 0;
}

//////////////////////////////////////////////////////////////////////
