#ifndef MPCFIO_HEADER
#define MPCFIO_HEADER

#define FAT_NOPREFIX (1)
#ifndef NULL
#define NULL (0)
#endif

/*
	CF Access for NDS

	FAT less header	for gba_nds_fat	 By SaTa.
	
	#define FAT_NOPREFIX 
	can access no "FAT_" prefix.
	
	

*/
#ifdef		FAT_NOPREFIX
#undef	InitFiles		
#undef	GetAlias		
#undef	GetLongFilename	
#undef	FindNextFile	
#undef	FindFirstFile	
#undef	chdir				
#undef	fopen			
#undef	fclose			
#undef	ftell			
#undef	fseek			
#undef	fread			
#undef	fwrite			
#undef	feof			
#undef	remove		
#undef	FreeFiles		
#undef	fgetc			
#undef	fputc			

#undef	fgets			
#undef	fputs			
#undef	mkdir
#undef	FileExists

#undef	FILE
#define	FILE		FAT_FILE


#define	InitFiles		FAT_InitFiles		
#define	GetAlias		FAT_GetAlias		
#define	GetLongFilename	FAT_GetLongFilename	
#define GetUniFilename FAT_GetLongFilenameUnicode

#define	FindNextFile	FAT_FindNextFile	
#define	FindFirstFile	FAT_FindFirstFile	
//#define	CWD				FAT_CWD				
#define	CWD				FAT_chdir				
#define	chdir			FAT_chdir				
#define	fopen			FAT_fopen			
#define	fclose			FAT_fclose			
#define	ftell			FAT_ftell			
#define	fseek			FAT_fseek			
#define	fread			FAT_fread			
#define	fwrite			FAT_fwrite			
#define	feof			FAT_feof			
//#define	DeleteFile		FAT_DeleteFile		
#define	DeleteFile		FAT_remove		
#define	remove			FAT_remove		

#define	FreeFiles		FAT_FreeFiles
#define	fgetc			FAT_fgetc		
#define	fputc			FAT_fputc		
#define	GetFileSize		FAT_GetFileSize		

#define	fgets			FAT_fgets
#define	fputs			FAT_fputs
#define	mkdir			FAT_mkdir
#define	FileExists		FAT_FileExists

#endif //	(FAT_NOPREFIX)

//#include "gbamp_cf.h"
//#include "gba_nds_fat.h"
#include "fat/gba_nds_fat.h"

//---------------------------------------------------------------
#ifdef __cplusplus
extern "C" {
#endif
//---------------------------------------------------------------
//#include "disc_io.h"
#include "fat/disc_io.h"
extern bool disc_Init(void) ;
extern LPIO_INTERFACE active_interface ;
//	0x46434353,	// 'SCCF'
//	0x4643504D,	// 'MPCF'
//	0x4643334D,	// 'M3CF'
//	0x44534353,	// 'SCSD'

#define DISC_IF_NONE	(0)
#define DISC_IF_SCCF	(0x46434353)
#define DISC_IF_SCSD	(0x44534353)
#define DISC_IF_MPCF	(0x4643504D)
#define DISC_IF_M3CF	(0x4643334D)
#define DISC_IF_M3SD	(0x4453334D)

inline u32 disc_if(void)
{
	if(active_interface==0)return 0;
	return active_interface->ul_ioType;
}

//------------------------------------------------------------------
#ifdef __cplusplus
}	   // extern "C"
#endif
//------------------------------------------------------------------



#endif // MPCFIO_HEADER


