

#ifndef NDSETC_HEADER
#define NDSETC_HEADER

#define printf XX__PRINTF_IS_INVALID__XX


#include <nds.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

//#include "../../header/gba.h"
//#include "../../header/boolean.h"
//#include "../../header/ipc_sound.h"


//#define exfile(ty,name) extern const ty name[]

//extern u8 __iwram_overlay_lma;		// gbat@Čɂt@C̃AhX
//#define moefs_root (u8 *)(&__iwram_overlay_lma)

//	荞ݏ
extern vu32 vs_count;
//void IRQ_Setup(void);


/*	GBA ֗֐W	*/

void WaitForVsync(void);
void wait(int frame);
void mem2clear(uint32 *V,uint32 data,int size);
void mem2vram(uint16 *D,uint16 *V,int size);
void setpal(uint16 *V,uint16 *D,int count);
tm *time2(tm *t);

// NDSp ֐	b
int isemu(void);	//G~[^=1 @=0;

/*
	0	{
	1	p
	2	tX
	3	hCc
	4	C^A
	5 	XyC
*/
int get_lang(void);
#define LANG_JP (0)
#define LANG_EN (1)



#define GBA_KEYS (*(vu16*)0x4000130)
/*	}N	*/
//L[܂ő҂
#define KEY_ALL		0x03FF
#define keywait() while( GBA_KEYS == KEY_ALL ){WaitForVsync();}
//L[܂ő҂^CAEgt
#define keywaitn(n) {int xx=0;while( GBA_KEYS == KEY_ALL ){if(xx>n)break;WaitForVsync();xx++;}}
//L[܂ő҂
#define nkeywait() while( GBA_KEYS != KEY_ALL ){WaitForVsync();}
//L[܂ő҂^CAEgt
#define nkeywaitn(n) {int xx=0;while( GBA_KEYS != KEY_ALL ){if(xx>n)break;WaitForVsync();xx++;}}
#define KEY_SEL_ST 0x03F3

#define isCANCEL !(GBA_KEYS & KEY_B)
#define isPAUSE  !(GBA_KEYS & KEY_START)
#define isEXE    !(GBA_KEYS & KEY_A)
#define isBREAK  (GBA_KEYS == KEY_SEL_ST)
#define isSHIFT !(GBA_KEYS & KEY_SELECT)

#define isBL     !(GBA_KEYS & KEY_L)
#define isBR     !(GBA_KEYS & KEY_R)

#define isCU !(GBA_KEYS & KEY_UP)
#define isCD !(GBA_KEYS & KEY_DOWN)
#define isCL !(GBA_KEYS & KEY_LEFT)
#define isCR !(GBA_KEYS & KEY_RIGHT)




//
#define GBA_REG_DMA0       0x40000B0
#define GBA_REG_DMA1       0x40000BC
#define GBA_REG_DMA2       0x40000C8
#define GBA_REG_DMA3       0x40000D4
#define GBA_DMA0_INTR_FLAG          0x0100
#define GBA_DMA1_INTR_FLAG          0x0200
#define GBA_DMA2_INTR_FLAG          0x0400
#define GBA_DMA3_INTR_FLAG          0x0800
 

//DMA MACRO
#define GBA_DMA_ENABLE              0x80000000
#define GBA_DMA_TIMMING_IMM         0x00000000
#define GBA_DMA_SRC_INC             0x00000000
#define GBA_DMA_SRC_FIX             0x01000000
#define GBA_DMA_DEST_INC            0x00000000
#define GBA_DMA_16BIT_BUS           0x00000000
#define GBA_DMA_32BIT_BUS           0x04000000

#define DmaSet(DmaNo, Srcp, Destp, DmaCntData)          \
{                                                       \
    vu32 *(DmaCntp) = (vu32 *)GBA_REG_DMA##DmaNo;           \
    DmaCntp[0] = (vu32 )(Srcp);                         \
    DmaCntp[1] = (vu32 )(Destp);                        \
    DmaCntp[2] = (vu32 )(DmaCntData);                   \
    DmaCntp[2];                                         \
}

#define DmaCopy(DmaNo, Srcp, Destp, Size, Bit)              \
                                                            \
    DmaSet(DmaNo, Srcp, Destp,  (                           \
        GBA_DMA_ENABLE         | GBA_DMA_TIMMING_IMM |              \
        GBA_DMA_SRC_INC        | GBA_DMA_DEST_INC    |              \
        GBA_DMA_##Bit##BIT_BUS | ((Size)/((Bit)/8))))

#define DmaFill(DmaNo, Srcp, Destp, Size, Bit)              \
                                                            \
    DmaSet(DmaNo, Srcp, Destp,  (                           \
        GBA_DMA_ENABLE         | GBA_DMA_TIMMING_IMM |              \
        GBA_DMA_SRC_FIX        | GBA_DMA_DEST_INC    |              \
        GBA_DMA_##Bit##BIT_BUS | ((Size)/((Bit)/8))))



#ifndef max
#define max(a,b)  (((a) > (b)) ? (a) : (b))
#endif

#ifndef min
#define min(a,b)  (((a) < (b)) ? (a) : (b))
#endif


#define RGB6(r,g,b) (g*6*6+r*6+b)

#endif
