#include <math.h>

#include "dbg.h"
#include "menuwin.h"


//#include "build/db1_pal.h"

#define PI (3.1416)

#include "mpcfio.h"

void dumpmain(void);



#define WT wait(10)

void dbgcfout(void)
{
char msg[256];
	FILE *fp;
	tm t;
//	int i;
	cls(0);
	print("SYSTEM INFO CF OUT\n");
	wait(10);
	nkeywait();
	
	for(;;)
	{
	//	if(CF_IsInserted())
		{
		//	print("CF_IsInserted() OK\n");
			WT;
			if(! InitFiles())
			{
					print("InitFiles() NG >");
			WT;
					keywait();
					print("\n");
					nkeywait();
					continue;
			}
					print("InitFiles() OK\n");
			WT;
			break;
		}
	//	else
	//	{
	//		print("CF_IsInserted() NG >");
	//		WT;
	//		keywait();
	//		print("\n");
	//		if(isCANCEL)
	//		{
	//			nkeywait();
	//			return;
	//		}
	//		nkeywait();
	//	}
	}
#define FW_VER			(*(vu8*) 0x023FFC80 )
#define FW_COLOR		(*(vu8*) 0x023FFC82 )
#define FW_BD_MM		(*(vu8*) 0x023FFC83 )
#define FW_BD_DD		(*(vu8*) 0x023FFC84 )
#define FW_NAME			((vu8*) 0x027FFC86 )
#define FW_NAME_LEN		(*(vu8*) 0x027FFC9A )
#define FW_MSG			((vu8*) 0x027FFC9C )
#define FW_MSG_LEN		(*(vu8*) 0x027FFCD0 )
#define FW_ALARM_HH		(*(vu8*) 0x027FFCD2 )
#define FW_ALARM_MM		(*(vu8*) 0x027FFCD3 )
#define FW_ALARM_ON		(*(vu8*) 0x027FFCD6 )
#define FW_SETTING		(*(vu8*) 0x027FFCE4 )

#define fout()	{print(msg);	fwrite(msg, strlen(msg),1, fp);}

	print("CWD /\n");
	CWD("/");

	print("time2()\n");
	time2(&t);

	print("fopen() ");
	fp=fopen("NDSINFO.TXT","a");
	
	if(fp==NULL)
	{
		print("ERROR\n");
	}
	else
	{
		print("OK\n");
	}
/*

t->tm_year 
t->tm_mon 
t->tm_mday 

t->tm_wday 

t->tm_hour 
t->tm_min 
t->tm_sec 
*/
	sprintf(msg,"NDS SYSTEM INFO\n"); fout();
	sprintf(msg,"RTC %4d/%02d/%02d %02d:%02d:%02d \n",
		t.tm_year ,
		t.tm_mon ,
		t.tm_mday ,
		t.tm_hour ,
		t.tm_min ,
		t.tm_sec 
	
		); fout();

		sprintf(msg,"TEMP %6.2fC\n",(float)IPC->temperature / (float)0x1000); fout();
	

	sprintf(msg,"FW_VER       %02d\n",FW_VER		); fout();
	sprintf(msg,"FW_COLOR     %02d\n",FW_COLOR	); fout();
	sprintf(msg,"FW_BD_MM     %02d\n",FW_BD_MM	); fout();
	sprintf(msg,"FW_BD_DD     %02d\n",FW_BD_DD	); fout();
//	sprintf(msg,"FW_NAME      %d\n",FW_NAME		); fout();
	sprintf(msg,"FW_NAME_LEN  %02d\n",FW_NAME_LEN); fout();
//	sprintf(msg,"FW_MSG       %d\n",FW_MSG		); fout();
	sprintf(msg,"FW_MSG_LEN   %02d\n",FW_MSG_LEN	); fout();
	sprintf(msg,"FW_ALARM_HH  %02d\n",FW_ALARM_HH); fout();
	sprintf(msg,"FW_ALARM_MM  %02d\n",FW_ALARM_MM); fout();
	sprintf(msg,"FW_ALARM_ON $%02X\n",FW_ALARM_ON); fout();
	sprintf(msg,"FW_SETTING  $%02X\n",FW_SETTING	); fout();
	
	fclose(fp);
	print("OK\n");
		wait(60);
	keywait();
	nkeywait();
}

void dbgdraw(void)
{
//	int i;
static drs pen0={0,0,0,0};
static drs pos0={256/2,192/2,0,0};
	u8 col[3]={RGB6(4,0,0),RGB6(0,3,0),RGB6(0,0,5)};
	int c=0;

	//	ʏ BG0̂ݎg

#define MAPBS (0)		//L
#define MAPBS2 (1)		//L
#define TIBS (1)		//C[W
#define TIBS2 (4)		//C[W
	uint16* map0 = (uint16*)BG_MAP_RAM(MAPBS);
	uint16* map1 = (uint16*)BG_MAP_RAM(MAPBS2);
	uint16* map2 = (uint16*)BG_MAP_RAM_SUB(MAPBS);
	uint16* map3 = (uint16*)BG_MAP_RAM_SUB(MAPBS2);

	uint16* BG_A = (uint16*)BG_TILE_RAM(TIBS);
	uint16* BG_B = (uint16*)BG_TILE_RAM(TIBS2);
	uint16* BG_C = (uint16*)BG_TILE_RAM_SUB(TIBS);
	uint16* BG_D = (uint16*)BG_TILE_RAM_SUB(TIBS2);

	vramSetMainBanks(VRAM_A_MAIN_BG  , VRAM_B_MAIN_BG  , VRAM_C_SUB_BG, VRAM_D_MAIN_BG  );
	 POWER_CR |= POWER_ALL_2D;
	lcdMainOnTop();		//	LCDmain/subւBftHgł͉main

 videoSetMode(MODE_0_2D | DISPLAY_BG0_ACTIVE   | DISPLAY_BG1_ACTIVE );
  videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE );


  BG0_CR = BG_256_COLOR | BG_MAP_BASE(MAPBS) | BG_TILE_BASE(TIBS)|BG_PRIORITY(0);
  BG1_CR = BG_256_COLOR | BG_MAP_BASE(MAPBS2) | BG_TILE_BASE(TIBS2)|BG_PRIORITY(1);

  SUB_BG0_CR = BG_256_COLOR | BG_MAP_BASE(MAPBS) | BG_TILE_BASE(TIBS)|BG_PRIORITY(2);
  SUB_BG1_CR = BG_256_COLOR | BG_MAP_BASE(MAPBS2) | BG_TILE_BASE(TIBS2)|BG_PRIORITY(3);

//	BG0_CR = BG_256_COLOR | BG_MAP_BASE(MAPBS) | BG_TILE_BASE(TIBS);
//	SUB_BG0_CR = BG_256_COLOR | BG_MAP_BASE(MAPBS) | BG_TILE_BASE(TIBS);

//	setpal(BG_PALETTE,(uint16*)db1_pal,256);
//	setpal(BG_PALETTE_SUB,(uint16*)db1_pal,256);
	BG_PALETTE_SUB[0]=BG_PALETTE[0]=RGB15(0,0,0);
	BG_PALETTE_SUB[255]=BG_PALETTE[255]=0xffff;
	BG_PALETTE_SUB[254]=BG_PALETTE[254]=RGB15(1,1,1);
	
						for(int i=0;i<(256*192/8/8);i++)
						{
							map0[i]=i;
							map1[i]=i;
							map2[i]=i;
							map3[i]=i;
						}
						mem2clear((uint32*)BG_A,0xFFFFFFFF,256*192);
						wait(1);
						mem2clear((uint32*)BG_C,0xFFFFFFFF,256*192);
						wait(1);
//						mem2clear((uint32*)BG_A,0,256*192);
						wait(1);
						mem2clear((uint32*)BG_B,0,256*192);
						wait(1);
//						mem2clear((uint32*)BG_C,0,256*192);
						wait(1);
						mem2clear((uint32*)BG_D,0,256*192);
						wait(1);

/*
		dr_tile(BG_A);
		dr_col(col[0]);
		dr_test();
		dr_tile(BG_C);
		dr_col(col[1]);
		dr_test();

						mem2clear((uint32*)BG_A,0,256*192);
						wait(1);
						mem2clear((uint32*)BG_B,0,256*192);
						wait(1);
						mem2clear((uint32*)BG_C,0,256*192);
						wait(1);
						mem2clear((uint32*)BG_D,0,256*192);
						wait(1);
						mem2clear((uint32*)BG_A,0xFFFFFFFF,256*192);
						wait(1);
						mem2clear((uint32*)BG_C,0xFFFFFFFF,256*192);
						wait(1);
*/


{
	//	`P	Ίp`
	//	px rad
	//	p` n=3 ... m
	//	a r
	float rad=PI*2;
	float r=192/2;
	float i,j,n;
	dr_origin(&pos0);

	for(n=3;n<=16;n++)
//	n=6;
	{
		for(i=0;i<n-1;i++)
		for(j=i+1;j<n;j++)
		{
			//	n_̍W
			pen0.x0=sin(i*rad/n)*r;
			pen0.y0=cos(i*rad/n)*r;
			//	I_̍W
			pen0.x1=sin(j*rad/n)*r;
			pen0.y1=cos(j*rad/n)*r;
			dr_col(col[c]);

			dr_tile(BG_A);
			dr_line(&pen0);
			dr_tile(BG_C);
			dr_line(&pen0);
			c=(c+1)%3;
		wait(2);
			
		}
		wait(60);
						mem2clear((uint32*)BG_A,0xFFFFFFFF,256*192);
						wait(1);
						mem2clear((uint32*)BG_C,0xFFFFFFFF,256*192);
						wait(1);
	}
}

	wait(60);
	keywait();

}

void dbgipc(void)
{
char msg[256];
	int i;
	cls(0);
	print("IPC STATUS\n");
	wait(10);
	nkeywait();
	for(;;)
	{
		locate(0,1);
		sprintf(msg,"t-b:$%04X ~$%04X \n",IPC->buttons,(~IPC->buttons)&0xFFFF);print(msg);
		sprintf(msg,"t-X:%5d $%04X \n",IPC->touchX,IPC->touchX);print(msg);
		sprintf(msg,"t-Y:%5d $%04X \n",IPC->touchY,IPC->touchY);print(msg);
		sprintf(msg,"tZ1:%5d $%04X \n",IPC->touchZ1,IPC->touchZ1);print(msg);
		sprintf(msg,"tZ2:%5d $%04X \n",IPC->touchZ2,IPC->touchZ2);print(msg);

			print("RTC 10:");
		for(i=0;i<8;i++)
		{
			sprintf(msg,"%02d",IPC->curtime[i]);print(msg);

		}
			print(" \n");
			print("RTC 16:");
		for(i=0;i<8;i++)
		{
			sprintf(msg,"%02X",IPC->curtime[i]);print(msg);

		}
			print(" \n");
		
		sprintf(msg,"temp:%6d $%04X \n",IPC->temperature,IPC->temperature);print(msg);
		sprintf(msg,"%6.2fC\n",(float)IPC->temperature / (float)0x1000);print(msg);
		sprintf(msg,"tdi1:%6d $%04X \n",IPC->tdiode1,IPC->tdiode1);print(msg);
		sprintf(msg,"tdi2:%6d $%04X \n",IPC->tdiode2,IPC->tdiode2);print(msg);
		


		if(isCANCEL)break;
		wait(10);
	}
}

void dbginput(void)
{
char msg[256];
ndskeys k;
u32 i;
int ct=0;
	i=isemu();

	cls(0);
	print("isemu=[");
		sprintf(msg,"_%03d_",i);
	print(msg);
	msg[0]='x';
	msg[1]=0;
	print(msg);
	print("] t_memomain");


	for(;;)
	{
		//	͊Ď
		//input
		i=getkey(&k);
//		if(i!=0)
		{
			if(k.key==0)
			{
				k.key=' ';
			}
			locate(0,ct+1);

			sprintf(msg,"r%1d[%03d,%03d]f%1d key:%c keys:%04X",i,k.x,k.y,k.f,k.key,k.keys);
			print(msg);

			ct=(ct+1)%22;
			locate(0,ct+1);
			//     00000000011111111112222222222333
			//     12345678901234567890123456789012
			print("                                ");
		}
		
		wait(10);
		//	y\
		//	x,y,i=0/1 ,j=0/1 qW
		
		
		//	͏
		//case
	if(isCANCEL)break;
	}


}





void dbgmain(void)
{
	int ret;
if(isemu()==1)keywaitn(30);



//	if(GBA_KEYS == KEY_ALL)return;
	if(!(isBL && isBR))return;

menu_s data[6]={
		"IPC(RTC,PEN,TMP)",			dbgipc,			
		"DUMP(GBA ROM=08/SRAM=0E)",	dumpmain,		
		"PEN INPUT TEST",			dbginput,		
		"SYSTEM INFO CF OUT",		dbgcfout,		
		"DRAW TEST",				dbgdraw,		
		NULL,						NULL,			
};



	for(;;)
	{
		cls(0);
//		print(" DEBUG MODE MENU\n");
		nkeywait();
//		ret=menu_win(mtitle,func);
		ret=menu_win("DEBUG MODE MENU",data);
		if(ret<0)break;

	}
}




void dbglog(char *msg,char *fname,int line)
{
	static char ofname[256]="";
	char fn[256];
	char buf[256];
	tm tim;

//	荞݋֎~
	int ime=IME;
	IME = 0;
	wait(1);
	time2(&tim);


	if(! InitFiles())return;

	sprintf(fn,"/LOG.TXT");
	FILE *dbgfp=fopen(fn,"a");
	if(dbgfp==NULL)
	{
		return;

	}




	if(strcmp(fname,ofname)==0)
	{
		sprintf(buf, " %d:",line);
	}
	else
	{
		sprintf(buf, "%s %d:", fname,line);
		strcpy(ofname,fname);
	}
	fwrite(buf,strlen(buf),1,dbgfp);

	fwrite(msg,strlen(msg),1,dbgfp);

	fwrite((void *)"\n",1,1,dbgfp);
	fclose(dbgfp);
	FreeFiles();

//	荞݋
	IME = ime;


}


void dbglogb(char *msg,int size)
{
	static char ofname[256]="";
	char fn[256];
	char buf[256];
	tm tim;

//	荞݋֎~
	int ime=IME;
	IME = 0;
	wait(1);


	if(! InitFiles())return;

	sprintf(fn,"/LOG.TXT");
	FILE *dbgfp=fopen(fn,"a");
	if(dbgfp==NULL)
	{
		return;

	}
	fwrite((void *)"\n",1,1,dbgfp);

	fwrite(msg,size,1,dbgfp);

	fwrite((void *)"\n",1,1,dbgfp);
	fclose(dbgfp);
	FreeFiles();

//	荞݋
	IME = ime;


}
