

#include "ndsetc.h"
#include "mzprint.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

void dumpmain(void)
{
	u32 i,j,k=0;
	u32 x=0x02000000;
	u32 ad=0x80;
	u8 *a;
	char msg[128];
	
	WAIT_CR &= ~0x0880;	// DS Card access ARM9:bit11=0   GBA Cart access ARM9:bit7=0


	cls(0);


	for(;;)
	{
		locate(0,0);
			k=x;
			sprintf(msg,"%08X-",k);
			print(msg);
		for(j=0;j<0x10;j++)
		{
			k=x+j*0x8;
			locate(0,j+1);
			sprintf(msg,"%04X:",k%0x10000);
			print(msg);
			for(i=0;i<0x8;i++)
			{
				a=(u8 *)k+i;
				sprintf(msg,"%02X",*a);
				print(msg);
			}
			for(i=0;i<0x8;i++)
			{
				a=(u8 *)k+i;
			//	locate(22+i,j+1);
			//	print(".");
				locate(22+i,j+1);
				if(*a>=0x20 && *a<0x80)
				{
				msg[0]=*a;
				}
				else
				{
				msg[0]='.';
				}
				msg[1]=0;
				print(msg);
			}
		}
	print("\nOK\n");
		keywait();
		
		if(isCANCEL)
		{
			return;
		}
		else
		if(isEXE)
		{
			x=0x08000000;
		}
		if(isBREAK)
		{
			return;
		}
		if(isCU)
		{
			x-=ad;
		}
		if(isCD)
		{
			x+=ad;
		}
		if(isCR)
		{
			x=0x02000000;
		}
		if(isCL)
		{
			x=0x03000000;
		}
		if(isBL)
		{
		WAIT_CR |= (0x8080);//GBA Cart ARM7
			x=0x04000000;
		}
		if(isBR)
		{
		WAIT_CR &= ~0x8080;	//GBA Cart ARM9
			x=0x06000000;
		}
		if(isPAUSE)
		{
			x=0x00000000;
		}
		if(isSHIFT)
		{
		//	wait(2);
		}
		else
		{

		wait(10);
		}

	}

}

