

#include "koyomi.h"
#include "mzprint.h"

void koyomi_ui(void)
{
	struct tm2 tim;
	struct tm2 tmp;
	char msg[80];
	time2(&tmp);
	//J_[
	koyomi(&tmp);
	//\
	for(;;)
	{
		locate((30-19)/2,18);
		time2(&tim);
		sprintf(msg, "%04d/%2d/%2d", tim.tm_year, tim.tm_mon,tim.tm_mday);
		print(msg);
		sprintf(msg, " %2d:%02d:%02d", tim.tm_hour, tim.tm_min,tim.tm_sec);
		print(msg);
		
		if(isCANCEL)
		{
			return;
		}
		else
		if(isEXE)
		{
			time2(&tmp);
			koyomi(&tmp);
			nkeywait();
		}
		if(isBREAK)
		{
			return;
		}
		if(isCU)
		{
			tmp.tm_mon--;
			if(tmp.tm_mon<1)
			{	tmp.tm_mon=12;tmp.tm_year--;}
			koyomi(&tmp);
			nkeywait();
		}
		if(isCD)
		{
			tmp.tm_mon++;
			if(tmp.tm_mon>12)
			{	tmp.tm_mon=1;tmp.tm_year++;}
			koyomi(&tmp);
			nkeywait();
		}
		if(isCR)
		{
			tmp.tm_year++;
			if(tmp.tm_year>2099)tmp.tm_year=2000;
			koyomi(&tmp);
			nkeywait();
		}
		if(isCL)
		{
			tmp.tm_year--;
			if(tmp.tm_year<2000)tmp.tm_year=2099;
			koyomi(&tmp);
			nkeywait();
		}


		wait(10);

	}

}








void ko_pal_set(void)
{
	int i,r,g,b;
	for(i=0;i<8;i++)
	{
		b=    i%2 * 31;
		r=(i/2)%2 * 31;
		g=(i/4)%2 * 31;
		mz_palet(i*16+0xF,RGB15(r,g,b));
	}
		mz_palet(0*16+0x0,RGB15(31,31,31));	// pal0̔wi͔
	
	//	mz_color(7);	//ɂ
}


int getdays(struct tm2 *tmp)
{
	//                [  1  2  3  4  5  6  7  8  9 10 11 12
	const u16 md[13]={29,31,28,31,30,31,30,31,31,30,31,30,31};
//	int w;
	if(tmp->tm_mon==2)
	{
		return md[uruuday(tmp->tm_year)];
	}
	return md[tmp->tm_mon];
}

//	j𓾂
int getwday(struct tm2 *tmp)
{
	int w;
	struct tm2 t;
	t=*tmp;
	
	if (t.tm_mon < 3) {t.tm_year--; t.tm_mon += 12;}
	w = 
	(
		t.tm_year
		+ t.tm_year/4 
		- t.tm_year/100 
		+ t.tm_year/400
		+ (13*t.tm_mon+8)/5
		+ t.tm_mday
	)%7;
	tmp->tm_wday=w;
	return w;
}

//	jՓ Ȃ -> 4Xy[X   -> 4̕
const char *holiday(struct tm2 *tmp)
{
	const char *ht[16]=
	{
		"    ",
		"",
		"",
		"ݺ",
		" ",
		"",
		"",
		"",
		"",
		"",
		"۳",
		" ",
		"",
		"ݶ",
		"۳",
		"ɳ",
	};
//	char *ret;
	int w;
	struct tm2 t;
	t=*tmp;
//	ret=ht[0];
	//	x
	//	6,8͋x݂Ȃ
	switch(tmp->tm_mon)
	{
		case 1:
			//U    			PP
			if(tmp->tm_mday==1)
			{
				return ht[1];
				break;
			}
			//l̓			PT
			if( (8<=tmp->tm_mday && tmp->tm_mday <=14) && (getwday(tmp)==1) )return ht[2];
			break;
		case 2:
			//LO̓  	Q11
			if(tmp->tm_mday==11)return ht[3];
			break;
		case 3:
			//t̓			R program
			//	syunbun=Math.floor(20.8431+0.242194*(n_Year-1980)-Math.floor((n_Year-1980)/4)) ;
			//w=(int)(20.8431+0.242194*(tmp->tm_year-1980)) - (int)((tmp->tm_year-1980)/4)) ;
			w=(int)(20.8431+0.242194*(tmp->tm_year-1980)-(int)((tmp->tm_year-1980)/4)) ;
			if(tmp->tm_mday==w)return ht[4];
			break;
		case 4:
			//݂ǂ̓		S29
			if(tmp->tm_mday==29)return ht[5];
			break;
		case 5:
			//@LO		TR
			//̋x		TS	x݂łȂꍇ
			//ǂ̓		TT
			if(tmp->tm_mday==3)return ht[6];
			if(tmp->tm_mday==4)return ht[7];
			if(tmp->tm_mday==5)return ht[8];
			break;
		case 7:
			//C̓  			VOT
			if( (15<=tmp->tm_mday && tmp->tm_mday <=21) && (getwday(tmp)==1) )return ht[9];
			break;
		case 9:
			//hV̓			XOT
			//H̓			X program
			if( (15<=tmp->tm_mday && tmp->tm_mday <=21) && (getwday(tmp)==1) )return ht[10];

			//syubun=Math.floor(23.2488+0.242194*(n_Year-1980)-Math.floor((n_Year-1980)/4)) ;
			w=(int)(23.2488+0.242194*(tmp->tm_year-1980)-(int)((tmp->tm_year-1980)/4)) ;
			if(tmp->tm_mday==w)return ht[11];
			break;
		case 10:
			//̈̓			10T
			if( (8<=tmp->tm_mday && tmp->tm_mday <=14) && (getwday(tmp)==1) )return ht[12];
			break;
		case 11:
			//̓  		11R
			//ΘJӂ̓  	1123
			if(tmp->tm_mday==3)return ht[13];
			if(tmp->tm_mday==23)return ht[14];
			break;
		case 12:
			//Vca		1223
			if(tmp->tm_mday==23)return ht[15];
			break;
	}
	return ht[0];
	//Uւ̓[Uōs
}

//	w肳ꂽ̃J_[\
void koyomi(struct tm2 *tmp)
{
	const u16 w[7]={0x4D0,0x4D1,0x4D2,0x4D3,0x4D4,0x4D5,0x4D6};
	const u16 ymd[3]={0x4D8,0x4D1,0x4D0};
	const u8  wcol[7]={2,0,0,0,0,0,1};
	char msg[80];
	const char *h;
	int x,y,i,day=1;
	int furikae=0;
	int top,last;
	struct tm2 t;
	t=*tmp;
	t.tm_mday=1;
	top=getwday(&t);
	last=getdays(&t);	//̌̍ŏI
	
	cls(0);
	ko_pal_set();
	mz_color(0);
	mz_hiragana();
	y=0;
	
	//N\	0s  9
	locate((30-8)/2,y+=2);
	sprintf(msg,"%4d",tmp->tm_year);
		print(msg);
	bg_put(ymd[0]);
	sprintf(msg,"%2d",tmp->tm_mon);
		print(msg);
	bg_put(ymd[1]);
	
	//j\ 1s  21
	x=(30-28)/2;
	locate(x,y+=2);
	for(i=0;i<7;i++)
	{
		mz_color(wcol[i]);
		print("  ");
		bg_put(w[i] | (wcol[i])<<12 );
		print(" ");
	}
	//\
	//Ps

//	locate(x,y+=2);
/*
	for(i=0;i<top;i++)
	{
		print("    ");
	}
*/
/*
	for(i=top;i<7;i++)
	{
		t.tm_mday=day;
		h=holiday(&t);
		if(h[0]==' ')
		{
		mz_color(wcol[i]);
		}
		else
		{
		mz_color(wcol[0]);
		}
		locate(x+i*4,y);
		sprintf(msg," %2d ",day);
		print(msg);
		locate(x+i*4,y+1);
		print(h);
		day++;
	}
*/
	
	i=top;

	//ԁ`[
	for(;day<=last;)
	{
		locate(x,y+=2);
		for(;i<7;i++)
		{
			if(last<day)
			{
				break;
			}
		t.tm_mday=day;
		h=holiday(&t);
		if(h[0]==' ')
		{
			if(furikae==1)
			{
				furikae=0;
				mz_color(wcol[0]);
				h="ض";
			}
			else
			{
				mz_color(wcol[i]);
			}
		}
		else
		{
			mz_color(wcol[0]);
			if(i==0)
			{
				furikae=1;
			}
			else
			{
				furikae=0;
			}
		}
		locate(x+i*4,y);
		sprintf(msg," %2d ",day);
		print(msg);
		locate(x+i*4,y+1);
		print(h);
		day++;
		}
		i=0;
	}
	
	mz_color(0);
}
