

#include "ndsetc.h"
#include "mzprint.h"
#include "cardme.h"
#include "koyomi.h"
#include "tt.h"
#include "menuwin.h"

#include "fileselect.h"
#include "savename.h"

#include "mpcfio.h"

//#define TITLE 
//#define TITLE "NDS EEPROM TOOL by SaTa." "\n" __DATE__ " " __TIME__


#define TITLE "M3-SAVE(DAT) MANAGER"




		void	m3_d2m(void);
		void	m3_m2d(void);
		void	m3_s2m(void);
		void	m3_m2s(void);


void m3_man(void)
{
	int ret;
menu_s data1[]={
//		"##############################"
	{	"DS->M3  /  DS-SAVE  -> M3-DAT", m3_d2m,},
	{	"M3->DS  /  DS-SAVE  <- M3-DAT", m3_m2d,},
//	{	"SAV->M3 / SAVE FILE -> M3-DAT", m3_s2m,},
//	{	"M3->SAV / SAVE FILE <- M3-DAT", m3_m2s,},
	{	NULL,NULL,},
};

	nkeywait();


	for(;;)
	{

		ret=menu_win(TITLE,data1);

		if(ret<0)break;
	
	}
	cls(0);
	nkeywait();
	print(".");
	keywaitn(10);

}


int eep_savefile(char *fn,char *mode);
int eep_loadfile(char *fn);

#define data eeptool_data
#define BUN (32)
//static u8 data[256*1024/BUN];
extern u8 data[256*1024/BUN];

int eep_dspinfo(void);


void	m3_d2m(void)
{
	int ret=0;
//	int tp;
	char *fn;
	char buff[80];

	cls(0);
	locate(0,0);
	print("DS->M3  /  DS-SAVE  -> M3-DAT\n");
	locate(0,2);
	print("PLEASE INSERT DS CARD and PUSH A\n");
	nkeywait();
	
	//
	if(eep_dspinfo()<0)return;

	nkeywait();

	fn=fileselect(".DAT");

	if(fn==NULL)
	{
		return;
	}
	

	cls(0);
	locate(0,0);
	print("DS->M3  /  DS-SAVE  -> M3-DAT\n");
	locate(0,2);
	sprintf(buff,"DS CARD:name=%s\n",getgamename((char *)data,4096,1));print(buff);
	sprintf(buff,"DS CARD:%s\n",getgamename((char *)data,4096,0));print(buff);

	locate(0,5);

	print("M3-DAT FILE NAME IS ");

	print(fn);
	print(".\n");
	
	print("OK? PUSH [START]\n");


	nkeywait();
		for(;;)
		{
			keywait();
			if(isPAUSE)
			{
				break;
			}
			if(isCANCEL)
			{
				return;
			}
			wait(1);
		}
	nkeywait();


	
	//	t@Cɕۑ鏈
	ret=eep_savefile(fn,"r+");
	//^[lĎs/
	if(ret<0)
	{
		print("NG\nFAILD COPY.");
	}
	else
	{
		print("OK\nSUCCESS.");
	}
	
	nkeywait();
	keywait();
}
void	m3_m2d(void)
{

	int ret=0;
	char *fn="FILE.SAV";
	char buff[80];
	
	cls(0);
	locate(0,0);
	print("M3->DS  /  DS-SAVE  <- M3-DAT\n");
	locate(0,2);
	print("PLEASE INSERT DS CARD and PUSH A\n");
	nkeywait();

	//
	if(eep_dspinfo()<0)return;

	nkeywait();

	
	fn=fileselect(".DAT");

	if(fn==NULL)
	{
		return;
	}

	cls(0);
	locate(0,0);
	print("M3->DS  /  DS-SAVE  <- M3-DAT\n");
	locate(0,2);
	sprintf(buff,"DS CARD:name=%s\n",getgamename((char *)data,4096,1));print(buff);
	sprintf(buff,"DS CARD:%s\n",getgamename((char *)data,4096,0));print(buff);

	locate(0,5);


	print("M3-DAT FILE NAME IS ");

	print(fn);
	print(".\n");
	



	print("OK ? PUSH [START]\n");


	nkeywait();
		for(;;)
		{
			keywait();
			if(isPAUSE)
			{
				break;
			}
			if(isCANCEL)
			{
				return;
			}
			wait(1);
		}
	nkeywait();



	
	//	t@C߂
	ret=eep_loadfile(fn);
	//^[lĎs/
	if(ret<0)
	{
		print("NG\nFAILD COPY.");
	}
	else
	{
		print("OK\nSUCCESS.");
	}
	
	keywait();
	nkeywait();

}
void	m3_s2m(void)
{
	cls(0);
	print("SAV to M3  /  SAVE FILE -> M3-SAVE(DAT)");
	
	
	
	nkeywait();
	keywait();
}
void	m3_m2s(void)
{
	cls(0);
	print("M3  to SAV /  SAVE FILE <- M3-SAVE(DAT)");
	
	
	
	nkeywait();
	keywait();
}


