
#include "memfile.h"

int memfile_save(char *fn,u8 *data,int len)
{
	FILE  *fp;
//	int i;

	if(! InitFiles())
	{
		return -1;
	}
	
	fp=fopen(fn,"w");
	
	if(fp==NULL)
	{
		FreeFiles();
		return -1;
	}
	fwrite(data, len,1, fp);

	fclose(fp);
	FreeFiles();
	return 0;
}

int memfile_load(char *fn,u8 *data,int len)
{
	FILE  *fp;
//	int i;

	if(! InitFiles())
	{
		return -1;
	}
	
	fp=fopen(fn,"r");
	
	if(fp==NULL)
	{
		FreeFiles();
		return -1;
	}
	fread(data, len,1, fp);

	fclose(fp);
	FreeFiles();
	return 0;
}

