


#include "ndsetc.h"
//#include "irq.h"

//vu32 gba_flame_count=0;
vu32 vs_count=0;
u32 vs_bios_flg=0;


u16 prg_crc16(const void* data, int len)
{
#define POLY	((1<<(15-15))|	\
		 (1<<(15- 2))|	\
		 (1<<(15- 0)))

	const unsigned char* p = (const unsigned char*)data;
	int i, r, v;

	r = 0xFFFF;

	while(len--) {
		v = *p++;
		for(i = 0; i < 8; i++) {
			if((r ^ v) & 1) {
				r = (r >> 1) ^ POLY;
			} else {
				r =  r >> 1;
			}
			v >>= 1;
		}
	}

	return r;

#undef POLY
}


int isemu(void)
{
static int nds_emu=9;
//static int nds_emu=1;
	if(nds_emu!=9)	return nds_emu;

/*	s
	//	BIOS CRC16̌vZŃG~[^f
	if(nds_emu==9)
	{
		u16 crc1;
		u16 crc2;
		char buf0[]="CRC-TEST";
			crc1=swiCRC16(0xFFFF,buf0,8);
			crc2=prg_crc16(buf0,8);
		if(crc1!=crc2)
		{
			nds_emu=1;
		}

	}
*/
	//	GBAJ[gANZXāA@ǂ̔f
	if(nds_emu==9)
	{
	//	u16 work[4];
		u16 work;
		WAIT_CR |= (0x0080);//GBA Cart ARM7
		wait(1);
		work=(u16)GBAROM[0];
		work=0;
		work|=(u16)GBAROM[0];
		work|=(u16)GBAROM[1];
		work|=(u16)GBAROM[2];
		work|=(u16)GBAROM[3];

		WAIT_CR &= ~0x0080;	//GBA Cart ARM9

		if(work==0x00)
		{
			nds_emu=0;
		}
		else
		{
			nds_emu=1;
		}
	}
	return nds_emu;
	
}

// ҂
void WaitForVsync(void)
{
//	while (*(volatile u16*)0x4000006>=160) {};
//	while (*(volatile u16*)0x4000006<160) {};
	if(vs_bios_flg==0)	//	BIOSWaitForVBlankgǂ
	{
		while (*(volatile u16*)0x4000006>=192) {};
		while (*(volatile u16*)0x4000006<192) {};
	}
	else
	{
		swiWaitForVBlank();
	}

}

// w肵t[ҋ@

//fobOpL[܂ő҂
//void wait(int frame){keywait();nkeywait();}
void wait(int frame){int i;	for(i=0;i<frame;i++) WaitForVsync();}



void mem2clear(uint32 *V,uint32 data,int size)
{
	DmaFill(3,&data,V,size,16);
//	DMA3_SRC=&data;
//	DMA3_DEST=V;
//	DMA3_CR=;
}


void mem2vram(uint16 *D,uint16 *V,int size)
{
//	dmaCopy(D,V,256*192*2);
//	dmaCopyWords(3,D,V,256*192*2);
//	dmaCopyHalfWords(3,D,V,256*192*2);
	int i;
	switch((int)D%4)
	{
		case 1:
		case 3:
			for(i=0;i<size/2;i++){V[i] = D[i];}
			break;
		case 2:
			dmaCopyHalfWords(3,D,V,size);
			break;
		case 0:
			dmaCopy(D,V,size);
			break;
	}

}

void setpal(uint16 *V,uint16 *D,int count)
{
	int i;
		for(i=0;i<count;i++){
			V[i] = D[i];
		}


}

/*


void sound_init(void)
{
	  IPC->mailRead = 0;

}

	int ch,vol,pan,rate;
void sound_play(void)
{
    ch=0;
    vol=SOUND_VOL_Max;
    pan=SOUND_PANPOT_Center;
    rate=11050;

		// SOUND_LOOP_Repeat or SOUND_LOOP_OneShot
	ipcsndDPlay_u8pcm(ch,rate,(u8*)GETRAW(pi_p11),GETRAWSIZE(pi_p11)/4,0,vol,pan,SOUND_LOOP_OneShot);
	

}

void sound_stop(void)
{
//	ipcsndDPlay_u8pcm(ch,rate,(u8*)GETRAW(pi_p11),GETRAWSIZE(pi_p11)/4,0,vol,pan,SOUND_LOOP_OneShot);
	ipcsndStop(ch);
}

*/


//	j𓾂
int tmp_getwday(struct tm *tmp)
{
	int w;
	struct tm t;
	t=*tmp;
	
	if (t.tm_mon < 3) {t.tm_year--; t.tm_mon += 12;}
	w = 
	(
		t.tm_year
		+ t.tm_year/4 
		- t.tm_year/100 
		+ t.tm_year/400
		+ (13*t.tm_mon+8)/5
		+ t.tm_mday
	)%7;
	tmp->tm_wday=w;
	return w;
}


//tm *GetRTC(tm *t)
tm *time2(tm *t)
{
	
//	tm t;
//	while(1)
//	wait(1);
	{
	// NbHH
	t->tm_year = IPC->curtime[1] + 2000;
	t->tm_mon = IPC->curtime[2];
	t->tm_mday = IPC->curtime[3];

//	t->tm_wday = IPC->curtime[4];	// fix me
	t->tm_wday = tmp_getwday(t);

	t->tm_hour = IPC->curtime[5];
	t->tm_min = IPC->curtime[6];
	t->tm_sec = IPC->curtime[7];

	if(t->tm_hour>=40)t->tm_hour-=40;
	//	15h -> 55h ??
	//if(t->tm_mday != 0)break;
	}
	return t;
}


#define FW_SETTING		(*(vu8*) 0x027FFCE4 )
	/*
	0x027FFCE4 bit 0..2 
	0x027FFCE4 bit 3 GBA[h 0= 1=
	0x027FFCE4 bit 6 [h 0=OFF 1=ON
	*/

int get_lang(void)
{
	return FW_SETTING & 0x07;
}
